#import "StringEx.h"

//StringExの実装
@implementation StringEx

//文字列の描画(4)
- (void)drawString:(NSString*)string 
    x:(float)x y:(float)y attrs:(NSDictionary*)attrs {
    [string drawAtPoint:CGPointMake(x,y) withAttributes:attrs];
}

//初期化
- (id)initWithCoder:(NSCoder*)coder {
    self=[super initWithCoder:coder];
    if (self) {
    }
    return self;
}

//描画
- (void)drawRect:(CGRect)rect {
    //フォントと文字色の指定(1)(2)
    NSDictionary* attrs=[NSDictionary dictionaryWithObjectsAndKeys:
        [UIFont systemFontOfSize:24],NSFontAttributeName,
        [UIColor colorWithRed:0/255.0f green:0/255.0f blue: 0/255.0f alpha:1.0f],
        NSForegroundColorAttributeName, nil];
    
    //文字列の描画(3)(4)
    [self drawString:[NSString stringWithFormat:@"画面サイズ:%dx%d",
        (int)[UIScreen mainScreen].bounds.size.width,
        (int)[UIScreen mainScreen].bounds.size.height] x:0 y:20 attrs:attrs];

    //文字幅の取得(5)
    CGSize size=[@"A" sizeWithAttributes:attrs];
    [self drawString:[NSString stringWithFormat:@"文字幅:%d",
        (int)size.width] x:0 y:20+26 attrs:attrs];
       
    //12ドットの文字列の描画
    attrs=[NSDictionary dictionaryWithObjectsAndKeys:
       [UIFont systemFontOfSize:12],NSFontAttributeName,
       [UIColor colorWithRed:255/255.0f green:0/255.0f blue: 0/255.0f alpha:1.0f],
       NSForegroundColorAttributeName, nil];
    [self drawString:@"12pt" x:0 y:20+26*2 attrs:attrs];

     //16ドットの文字列の描画
    attrs=[NSDictionary dictionaryWithObjectsAndKeys:
       [UIFont systemFontOfSize:16],NSFontAttributeName,
       [UIColor colorWithRed:0/255.0f green:255/255.0f blue: 0/255.0f alpha:1.0f],
       NSForegroundColorAttributeName, nil];
    [self drawString:@"16pt" x:0 y:20+26*3 attrs:attrs];

    //24ドットの文字列の描画
    attrs=[NSDictionary dictionaryWithObjectsAndKeys:
       [UIFont systemFontOfSize:24],NSFontAttributeName,
       [UIColor colorWithRed:0/255.0f green:0/255.0f blue: 255/255.0f alpha:1.0f],
       NSForegroundColorAttributeName, nil];
    [self drawString:@"24pt" x:0 y:20+26*4 attrs:attrs];
}
@end
