#include "TimerEx.h"

//TimerExの実装
@implementation TimerEx

//初期化
- (id)initWithCoder:(NSCoder*)coder {
    self=[super initWithCoder:coder];
    if (self) {
        self.backgroundColor=[UIColor whiteColor];
 
        //画像の読み込み
        _image=[UIImage imageNamed:@"sample.png"];

        //変数の初期化
        _px=[UIScreen mainScreen].bounds.size.width/2;
        _py=[UIScreen mainScreen].bounds.size.height/2;
        _vx=4.0f;
        _vy=4.0f;
        _timer=nil;
    }
    return self;
}

//描画
- (void)drawRect:(CGRect)rect {
    //イメージの描画
    [_image drawAtPoint:(CGPointMake(
        _px-_image.size.width/2,_py-_image.size.height/2))];
}

//タッチ終了イベントの処理
- (void)touchesEnded:(NSSet*)touches withEvent:(UIEvent*)event {
    if (_timer==nil) {
        //タイマーの生成(1)        
        _timer=[NSTimer scheduledTimerWithTimeInterval:1.0f/30.0f
            target:self
            selector:@selector(onTick:)
            userInfo:nil
            repeats:YES];
    } else {
        //タイマーの停止(2)
        [_timer invalidate];
        _timer=nil;
    }
}

//定期処理(3)
- (void)onTick:(NSTimer*)timer {
    //移動
    _px+=_vx;//X座標
    _py+=_vy;//Y座標
    if (_px<0.0f)                    _vx= 4.0f;//左端反転
    if (self.bounds.size.width <_px) _vx=-4.0f;//右端反転
    if (_py<0.0f)                    _vy= 4.0f;//上端反転
    if (self.bounds.size.height<_py) _vy=-4.0f;//下端反転
    
    //再描画
    [self setNeedsDisplay];
}
@end
