#import "LabelEx.h"

//LabeExの実装
@implementation LabelEx

//ラベルの生成(1)
- (UILabel*)makeLabel:(CGPoint)pos text:(NSString*)text font:(UIFont*)font {
    UILabel* label=[[UILabel alloc] init];
    [label setFrame:CGRectMake(pos.x,pos.y,9999,9999)];
    [label setText:text];
    [label setFont:font];
    [label setTextAlignment:NSTextAlignmentLeft];
    [label setLineBreakMode:NSLineBreakByWordWrapping];
    [label setNumberOfLines:0];
    [label sizeToFit];//(2)
    return label;
}

//イメージビューの生成(4)
- (UIImageView*)makeImageView:(CGRect)rect image:(UIImage*)image {
    UIImageView* imageView=[[UIImageView alloc] init];
    [imageView setFrame:rect];
    [imageView setImage:image];
    return imageView;
}

//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
        
    //ラベルの生成
    UILabel* label=[self makeLabel:CGPointMake(0,20)
        text:@"これはテストです" 
        font:[UIFont systemFontOfSize:24]];
    
    //コンポーネントの配置(3)
    [self.view addSubview:label];
        
    //イメージビューの生成
    UIImageView* imageView=[self makeImageView:
        CGRectMake(0,70,80,80)
        image:[UIImage imageNamed:@"sample.png"]];

    //コンポーネントの配置(3)
    [self.view addSubview:imageView];
}
@end