#import "AppDelegate.h"
#import "BackgroundTaskEx.h"

//AppDelegateの実装
@implementation AppDelegate

//アプリ起動時に呼ばれる
- (BOOL)application:(UIApplication*)application
    didFinishLaunchingWithOptions:(NSDictionary*)launchOptions {
    //ウィンドウの生成
    self.window=[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    self.window.backgroundColor=[UIColor whiteColor];
    [self.window makeKeyAndVisible];
    
    //ビューの生成
    self.window.rootViewController=[[BackgroundTaskEx alloc] init];
    return YES;
}

//バックグラウンド遷移時に呼ばれる
- (void)applicationDidEnterBackground:(UIApplication*)application {
    //バックグラウンドタスクの開始(1)
    UIApplication* app=[UIApplication sharedApplication];
    _bgTask=[app beginBackgroundTaskWithExpirationHandler:^{
        //バックグラウンドタスクの終了(2)
        [app endBackgroundTask:_bgTask];
        _bgTask=UIBackgroundTaskInvalid;
    }];
    dispatch_async(dispatch_get_global_queue(
        DISPATCH_QUEUE_PRIORITY_DEFAULT,0), ^{
        //バックグラウンドタスクの記述
        NSLog(@"バックグラウンドタスクの処理を記述");
        
        //ローカルノーティフィケーションの表示(3)
        UILocalNotification* notification=[[UILocalNotification alloc] init];
        notification.alertBody=@"バックグラウンドタスクの処理が完了";
        [app presentLocalNotificationNow:notification];
        
        //バックグラウンドタスクの終了(2)
        [app endBackgroundTask:_bgTask];
        _bgTask=UIBackgroundTaskInvalid;
    });
}
@end
