#import "MyScene.h"

//シーンの実装
@implementation MyScene

//初期化時に呼ばれる
- (id)initWithSize:(CGSize)size {
    if (self=[super initWithSize:size]) {
        //シーンの設定
        self.backgroundColor=[SKColor whiteColor];
        self.scaleMode      =SKSceneScaleModeAspectFit;
    }
    return self;
}

//トランジション種別の指定
- (void)setTransitionType:(int)type {
    _type=type;
    
    //スプライトの追加
    NSString* imageName=(_type%2==0)?@"sample0.png":@"sample1.png";
    SKTexture* rocketTexture = [SKTexture textureWithImageNamed:imageName];
    SKSpriteNode* sprite=[SKSpriteNode spriteNodeWithTexture:rocketTexture];
    sprite.position=CGPointMake(self.frame.size.width/2,self.frame.size.height/2);
    sprite.size=CGSizeMake(320,320);
    [self addChild:sprite];
}

//タッチ時に呼ばれる
- (void)touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event {
    //シーンの生成
    MyScene* scene=[MyScene sceneWithSize:self.frame.size];
    _type=(_type+1)%12;
    [scene setTransitionType:_type];
    
    //トランジションの生成(2)
    SKTransition* trans=nil;
    if (_type== 1) trans=[SKTransition doorsCloseHorizontalWithDuration:0.5];
    if (_type== 2) trans=[SKTransition doorsCloseVerticalWithDuration:0.5];
    if (_type== 3) trans=[SKTransition doorsOpenHorizontalWithDuration:0.5];
    if (_type== 4) trans=[SKTransition doorsOpenVerticalWithDuration:0.5];
    if (_type== 5) trans=[SKTransition doorwayWithDuration:0.5];
    if (_type== 6) trans=[SKTransition fadeWithColor:[SKColor whiteColor]
        duration:0.5];
    if (_type== 7) trans=[SKTransition fadeWithDuration:0.5];
    if (_type== 8) trans=[SKTransition flipHorizontalWithDuration:0.5];
    if (_type== 9) trans=[SKTransition flipVerticalWithDuration:0.5];
    if (_type==10) trans=[SKTransition moveInWithDirection:SKTransitionDirectionUp
        duration:0.5];
    if (_type==11) trans=[SKTransition pushWithDirection:SKTransitionDirectionUp
        duration:0.5];
    if (_type== 0) trans=[SKTransition revealWithDirection:SKTransitionDirectionUp
        duration:0.5];
    
    //シーンの遷移
    [self.view presentScene:scene transition:trans];
}
@end
