#import "MyScene.h"

//シーンの実装(4)
@implementation MyScene

//初期化時に呼ばれる
-(id)initWithSize:(CGSize)size {
    if (self=[super initWithSize:size]) {
        //シーンの設定(4)
        self.backgroundColor=[SKColor whiteColor];     //背景色
        self.scaleMode      =SKSceneScaleModeAspectFit;//スケールモード
        
        //ラベルの追加(5)
        SKLabelNode* label=[SKLabelNode labelNodeWithFontNamed:@"ArialMT"];
        label.text     =@"Hello SpriteKit!";
        label.fontSize =20;
        label.fontColor=[SKColor blackColor];
        label.position =CGPointMake(
            self.frame.size.width/2,self.frame.size.height/2);
        [self addChild:label];
    }
    return self;
}

//タッチ時に呼ばれる
- (void)touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event {
    //タッチ位置の取得
    UITouch* touch=[[touches allObjects] objectAtIndex:0];
    CGPoint location=[touch locationInNode:self];
    
    //スプライトの追加(6)
    SKSpriteNode* sprite=[SKSpriteNode spriteNodeWithImageNamed:@"sample.png"];
    sprite.position=location;
    [self addChild:sprite];
    
    //スプライトのアクションの追加(7)
    SKAction* action=[SKAction rotateByAngle:M_PI duration:1];
    action = [SKAction repeatActionForever:action];
    [sprite runAction:action];
}

//フレームの更新開始時に呼ばれる
- (void)update:(CFTimeInterval)currentTime {
}

//ノードのアクションの処理後に呼ばれる
- (void)didEvaluateActions {
}

//物理シミュレーションの処理後に呼ばれる
- (void)didSimulatePhysics {
}
@end
